//+------------------------------------------------------------------+
//|                                                       MY-RSI.mq4 |
//|                                                             Alex |
//|                                                    pupok-alex.ru |
//+------------------------------------------------------------------+
#property copyright "Alex"
#property link      "pupok-alex.ru"

#property indicator_separate_window

#property indicator_buffers 3

#property indicator_minimum 0
#property indicator_maximum 100

#property indicator_color1  White
#property indicator_color2  Red
#property indicator_color3  Yellow
#property indicator_color4  Blue


// buffers
double Values[];           //  
double SmoothedValues1[];   //  
double SmoothedValues2[];   //  
double Crosses[];          // 
extern int RSIPeriod       = 5;
extern int AppliedPrice    = 0;
extern int MAPeriod1        = 3;
extern int MAPeriod2        = 5;

int DigitsUsed = 8;
int EmptyValueUsed = 0;

int init()
{
   //  
   SetIndexBuffer(0, Values);
   SetIndexBuffer(1, SmoothedValues1);
   SetIndexBuffer(2, SmoothedValues2);
   SetIndexBuffer(3, Crosses);
   
   //    
   SetIndexStyle(0, DRAW_LINE);     //     
   SetIndexStyle(1, DRAW_LINE, STYLE_DASH); //  -- 
   SetIndexStyle(2, DRAW_LINE, STYLE_DASH); //  -- 
   SetIndexStyle(3, DRAW_ARROW, STYLE_SOLID, 2); //  --  
   
   SetIndexArrow(3, 251);
   
   IndicatorDigits(DigitsUsed);
   
   SetIndexDrawBegin(0, RSIPeriod);
   SetIndexDrawBegin(1, RSIPeriod + MAPeriod1);
   SetIndexDrawBegin(2, RSIPeriod + MAPeriod1 + MAPeriod2);
   SetIndexDrawBegin(3, RSIPeriod + MAPeriod1 + MAPeriod2 + 1);
   
   return(0);
}

int start()
{
   int toCount = Bars - IndicatorCounted();  
   
   //  
   for (int i = toCount - 1; i >=0; i--)
   {
      Values[i] = NormalizeDouble(iRSI(Symbol(), 0, RSIPeriod, AppliedPrice, i), DigitsUsed);
   }
      
   //   
   for (i = toCount - 1; i >=0; i--)
   {
      SmoothedValues1[i] = NormalizeDouble(iMAOnArray(Values, 0, MAPeriod1, 0, MODE_SMA, i), DigitsUsed);
      SmoothedValues2[i] = NormalizeDouble(iMAOnArray(Values, 0, MAPeriod2, 0, MODE_SMA, i), DigitsUsed);
   }
      
   
   return(0);
}